﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.8
@EndOfDesignText@
' v 1.01
'
' src --> file:///.\Objects\src\b4a\example\rtdev\richedit.java
'
#Region --- Info ---
' This class is inspired by wrap from somed3v3loper --> https://www.b4x.com/android/forum/threads/richeditor-view.66319/#content
' 									  original lib  --> https://github.com/wasabeef/richeditor-android
'
' 	B4A search for relating threads --> https://www.b4x.com/android/forum/pages/results/?query=SMMRichEditor
'
' 	klaus's "Routines for selecting text and cursor management for EDITTEXT  --> https://www.b4x.com/android/forum/threads/edittext-utils.43479/#content 
'
'    In Debug mode mind this information --> https://www.b4x.com/android/forum/threads/images-loaded-in-webviews-are-not-displayed-in-mode-%E2%80%9Cdebug-rapid-%E2%80%9D-b4a-3-50-version.38981/#post-230988
'

	' --> https://www.b4x.com/android/forum/threads/spannable-text-to-html.102824/
	
	' --> https://www.b4x.com/android/forum/threads/save-and-load-csbuilders.98257/#content
	' --> https://www.b4x.com/android/forum/threads/save-load-text-formatted.92263/#post-583681
	
	' --> https://www.b4x.com/android/forum/threads/save-load-text-formatted.92263/#post-583864
#End Region	

#Region --- Richtexteditor html related infos ---
	' --- from .\files\editor.html
	'		<!DOCTYPE html>
	'		<html>
	'		<head>
	'		    <meta name="viewport" content="user-scalable=no">
	'		    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	'		    <link rel="stylesheet" Type="text/css" href="normalize.css">
	'		    <link rel="stylesheet" Type="text/css" href="style.css">
	'		</head>
	'		<body>
	'		<div id="editor" contentEditable="true"></div>
	'		<script Type="text/javascript" src="rich_editor.js"></script>
	'		</body>
	'		</html>

	' --- from .\files\style.css
	'		html {
	'		  height: 100%;
	'		}
	'
	'		body {
	'		  overflow: hidden;
	'		  display: table;
	'		  table-layout: fixed;
	'		  width: 100%;
	'		}
	'
	'		#editor {
	'		  display: table-cell;
	'
	'		  -webkit-user-Select: auto !important;
	'		  -webkit-user-modify: read-write !important;
	'
	'		  outline: 0px solid transparent;
	'		  background-repeat: no-repeat;
	'		  background-position: center;
	'		  background-size: cover;
	'		}
	'
	'		#editor[placeholder]:empty:not(:focus):before {
	'		  content: attr(placeholder);
	'		  opacity: .2;
	'		}}


' --- from .\files\richeditor.js:
' 
'		RE.backuprange 
'		RE.blurFocus 
'		RE.callback();
'		RE.currentSelection

'		RE.editor.addEventListener("click", RE.enabledEditingItems);
'		RE.editor.addEventListener("input", RE.callback);
'		RE.editor.addEventListener("keyup", function(e) {
'		RE.editor.blur();
'		RE.editor.focus();
'		RE.editor.setAttribute("placeholder", placeholder);
'		RE.editor.style.backgroundImage = image;
'		RE.editor.style.color  = color;
'		RE.editor.style.fontSize = size;
'		RE.editor.style.minWidth = size;
'		RE.editor.style.paddingBottom = bottom;
'		RE.editor.style.paddingLeft = left;
'		RE.editor.style.paddingRight = right;
'		RE.editor.style.paddingTop = top;
'		RE.editor.style.textAlign = align;
'		RE.editor.style.verticalAlign = align;

'		RE.enabledEditingItems = function(e) {
'		RE.enabledEditingItems(e);
'		RE.focus 
'		RE.insertHTML = function(html) {
'		RE.insertHTML(html);
'		RE.insertImage = function(url, alt) {
'		RE.insertLink = function(url, title) {
'		RE.prepareInsert 
'		RE.redo 
'		RE.removeFormat 
'		RE.restorerange();

'		RE.setBackgroundColor = function(color) {
'		RE.setBackgroundImage = function(image) {
'		RE.setBaseFontSize = function(size) {
'		RE.setBaseTextColor = function(color) {
'		RE.setBlockquote 
'		RE.setBold 
'		RE.setBullets 
'		RE.setFontSize = function(fontSize){
'		RE.setHeading = function(heading) {
'		RE.setHeight = function(size) {
'		RE.setIndent 
'		RE.setItalic 
'		RE.setJustifyCenter 
'		RE.setJustifyLeft 
'		RE.setJustifyRight 
'		RE.setNumbers 
'		RE.setOutdent 
'		RE.setPadding = function(left, top, right, bottom) {
'		RE.setPlaceholder = function(placeholder) {
'		RE.setStrikeThrough 
'		RE.setSubscript 
'		RE.setSuperscript 
'		RE.setTextAlign = function(align) {
'		RE.setTextBackgroundColor = function(color) {
'		RE.setTextColor = function(color) {
'		RE.setTodo = function(text) {
'		RE.setUnderline 
'		RE.setVerticalAlign = function(align) {
'		RE.setWidth = function(size) {

'		RE.undo 

'		range.selectNodeContents(RE.editor);
'		range.setEnd(RE.currentSelection.endContainer, RE.currentSelection.endOffset);
'		range.setStart(RE.currentSelection.startContainer, RE.currentSelection.startOffset);

#End Region

Sub Class_Globals
	Private FormatState_IsBold As Boolean = False
	Private FormatState_IsBullets As Boolean = False
	Private FormatState_IsUnderline As Boolean = False
	
	Private HolderPanel As Panel
	Private cCallback As Object
	Private cEventName As String

	Private ActionButtonPanel As Panel
	Private rte As SMMRichEditor ' --> https://www.b4x.com/android/forum/threads/richeditor-view.66319/#content
	
	Private imeRd As IME
	Private DetailsDialog As CustomLayoutDialog
	Private ActionButtonPanelWidthHeight As Int = 40dip
	Private DisplayHeight As Int = 0
End Sub

Public Sub Initialize(Holder As Panel, Callback As Object, EventName As String)
	HolderPanel = Holder
	cCallback = Callback
	cEventName = EventName
	
	imeRd.Initialize("imeRd")
	imeRd.AddHeightChangedEvent
End Sub
Sub imeRd_HeightChanged (NewHeight As Int, OldHeight As Int)
	DisplayHeight = NewHeight
End Sub

' InputParameters keys:
'   title - Info above Dialog
'   positive - Buttontext for OK function
'   cancel - Buttontext for cancel function
'   hint - Text shown if editor is empty
'   preset - Html string of formatted text
'   fontsize - A value between 1-7
Sub Input(InputParameters As Map, DialogHeightInside As Int) As ResumableSub
	Dim EditorHeight As Int = DialogHeightInside -(3 *48dip)
	
	Dim sf As Object = DetailsDialog.ShowAsync(InputParameters.Get("title"), InputParameters.Get("positive"), InputParameters.Get("cancel"), "", Null, True)
	DetailsDialog.SetSize(HolderPanel.Width, DialogHeightInside)
	Wait For (sf) Dialog_Ready(Dialogpanel As Panel)
	
	rte.Initialize("rte")
	rte.EditorBackgroundColor = Colors.White
	rte.EditorHeight = EditorHeight
	rte.EditorFontSize = InputParameters.Get("fontsize")
	rte.EditorFontColor = Colors.DarkGray
	rte.EditorBackgroundColor = Colors.White
	rte.Padding = Array As Int(10,10,10,10)
	rte.Placeholder = InputParameters.Get("hint")
	rte.Html = InputParameters.Get("preset")
	
	ActionButtonPanel.Initialize("")
	ActionButtonPanel.Color = Colors.LightGray
	
	AddButton("FormatButton_Bold", Chr(0xE238) )
	AddButton("FormatButton_Underline", Chr(0xE249) )
	AddButton("FormatButton_Bullets", Chr(0xE241) )
	AddButton("", "")
	AddButton("FormatButton_InsertImage", Chr(0xE3F4))
	AddButton("", "")
	AddButton("FormatButton_Undo", Chr(0xE166) )
	
	' The functions of the Context menu will be replaced later by those:
	'	AddButton("", "")
	'	AddButton("FormatButton_Clear",  Chr(0xE14C))
	'	AddButton("FormatButton_Cut", Chr(0xE14E) )
	'	AddButton("FormatButton_Copy", Chr(0xE14D) )
	'	AddButton("FormatButton_Paste", Chr(0xE14F) )
	'	AddButton("FormatButton_SelectAll", Chr(0xE162))
	
	Dialogpanel.Addview(ActionButtonPanel, Dialogpanel.Width- ActionButtonPanelWidthHeight, 0, ActionButtonPanelWidthHeight, Dialogpanel.Height)
	Dialogpanel.Addview(rte, 0, 0, Dialogpanel.Width -ActionButtonPanelWidthHeight, Dialogpanel.Height)
		
	Sleep(0)
	imeRd.ShowKeyboard(rte)
	Wait For (sf) Dialog_Result(res As Int)
	
	Sleep(0)
	imeRd.HideKeyboard
	If res = DialogResponse.POSITIVE Then
		Return rte.Html
	Else
		Return ""
	End If
End Sub
 
Sub AddButton(EventName As String, MdChar As String)
	Dim NewPos As Int = ActionButtonPanel.NumberOfViews
	If EventName.Length=0 Then
		Dim EmptyLabel As Label
		EmptyLabel.Initialize("")
		If ActionButtonPanel.Width > ActionButtonPanel.Height Then
			' Horizontal
			ActionButtonPanel.AddView(EmptyLabel, NewPos *(ActionButtonPanelWidthHeight -4dip), 0, ActionButtonPanelWidthHeight, ActionButtonPanelWidthHeight)
		Else
			' Vertical
			ActionButtonPanel.AddView(EmptyLabel, 0, NewPos *(ActionButtonPanelWidthHeight -4dip), ActionButtonPanelWidthHeight, ActionButtonPanelWidthHeight)
		End If
		Return
	End If
	Dim ActionButton As Button
	ActionButton.Initialize(EventName)
	ActionButton.Typeface = Typeface.MATERIALICONS
	ActionButton.Gravity = Gravity.CENTER
	ActionButton.TextSize = 18
	ActionButton.Text = MdChar
	If ActionButtonPanel.Width > ActionButtonPanel.Height Then
		' Horizontal
		ActionButtonPanel.AddView(ActionButton, NewPos *(ActionButtonPanelWidthHeight -4dip), 0, ActionButtonPanelWidthHeight, ActionButtonPanelWidthHeight)
	Else
		' Vertical
		ActionButtonPanel.AddView(ActionButton, 0, NewPos *(ActionButtonPanelWidthHeight -4dip), ActionButtonPanelWidthHeight, ActionButtonPanelWidthHeight)
	End If
End Sub

Sub FormatButton_Bold_Click
	If FormatState_IsBold Then
		rte.setBold
		rte.removeFormat
	Else
		rte.removeFormat
		rte.setBold
	End If
	FormatState_IsBold = Not(FormatState_IsBold)
End Sub
Sub FormatButton_Underline_Click
	If FormatState_IsUnderline Then
		rte.setUnderline
		rte.removeFormat
	Else
		rte.removeFormat
		rte.setUnderline
	End If
	FormatState_IsUnderline = Not(FormatState_IsUnderline)
End Sub
Sub FormatButton_Bullets_Click
	If FormatState_IsBullets Then
		rte.setBullets
		rte.removeFormat
	Else
		rte.removeFormat
		rte.setBullets
	End If
	FormatState_IsBullets = Not(FormatState_IsBullets)
End Sub
Sub FormatButton_Undo_Click
	rte.undo
End Sub
Sub FormatButton_InsertImage_Click
	' Testmechanism as replacement for Imageselect etc.
	rte.insertImage("file://" & File.Combine(File.DirInternal, "test.jpg"),"TESTIMAGE xyz") '####test
End Sub




' --- --- --- --- --- --- --- --- --- 
' Erel --> https://www.b4x.com/android/forum/threads/custom-context-menu-for-text-selection.81596/#content
' --- --- --- --- --- --- --- --- --- 
Sub ContextMenu_Create(ActionMode As JavaObject, FocusedView As View)
	Dim menu As JavaObject = ActionMode.RunMethod("getMenu", Null)
	menu.RunMethod("clear", Null)
	Dim event As Object = menu.CreateEvent("android.view.MenuItem.OnMenuItemClickListener", "ContextMenuClick", True)
	
	For Each s As String In Array("Set As Title", "Delete") 'menu items here
		menu.RunMethodJO("add", Array(s)).RunMethod("setOnMenuItemClickListener", Array(event))
	Next
	Wait For ContextMenuClick_Event (MethodName As String, Args() As Object)
	Dim MenuItem As JavaObject = Args(0)
	Dim title As String = MenuItem.RunMethod("getTitle", Null)
	Log(title & " was clicked!") '<---- do what ever you like with the click!!!
	If FocusedView Is EditText Then
		Dim et As EditText = FocusedView
		Dim jo As JavaObject = Me
		Dim selectionLength As Int = jo.RunMethod("getSelectionLength", Array(et)) 'will be available in the next version of B4A!
		Dim selectionStart As Int = et.SelectionStart
		Select title
			Case "Set As Title"
				'Activity.Title = et.Text.SubString2(selectionStart, selectionLength + selectionStart)
				Log("x330, -->" & et.Text.SubString2(selectionStart, selectionLength + selectionStart) )
			Case "Delete"
				et.Text = et.Text.SubString2(0, selectionStart) & _
					et.Text.SubString(selectionStart + selectionLength)
		End Select
	End If
	ActionMode.RunMethod("finish", Null)
End Sub

#if Java
 
 import android.view.*;
 import anywheresoftware.b4a.AbsObjectWrapper;
 import android.text.Selection;
 import android.widget.EditText;

    @Override
    public void onActionModeStarted(ActionMode mode) {
		processBA.raiseEvent(this, "contextmenu_create", AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4j.object.JavaObject(), mode),
			AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.ConcreteViewWrapper(), getCurrentFocus()));
        super.onActionModeStarted(mode);
    }

    @Override
    public void onActionModeFinished(ActionMode mode) {
        super.onActionModeFinished(mode);
    }
	public static int getSelectionLength(EditText et) {
		return Selection.getSelectionEnd(et.getText()) - Selection.getSelectionStart(et.getText());
	}

#End If
' --- --- --- --- --- --- --- --- --- 